
module.exports.type = 'request-hook'

module.exports.meta = {
  name: 'slipname',
  description: '名前欄に入力された!ver!を実際に書き込んだ際のBBSSLIPに置き換えます',
  version: '1.0.2',
  needVersion: '0.28.2'
}

const p_ver = '%21%76%65%72%21'

module.exports.beforeRequest = async (tools, url, method, headers, payload, query) => {
  try {
    if (url?.match(/5ch\.net\/test\/bbs\.cgi.*?/) && payload?.match(`FROM=[^&]*${p_ver}[^&]*`)) {
      let board2slip = tools.conf.get('bbsslip_verify') || {}
      let [, original] = payload.match(/FROM=([^&]+)/) ?? []
      let newname
      if (original) {
        let board = payload.replace(/.*?bbs=(\w+).*?$/, '$1')
        if (board2slip[board]) {
          newname = original.replace(p_ver, encodeURIComponent(board2slip[board]))
        } else {
          tools.conf.set('bbsslip_verify', { ...board2slip, [board]: '' })
        }
      }
      if (!newname) {
        newname = original.replace(p_ver, '')
      }
      payload = payload.replace(/FROM=([^&]+)/, `FROM=${newname}`)
    }
  } catch (e) {
    console.error(e)
  }
  return { url, headers, payload, method }
}

module.exports.afterRequest = async (tools, url, method, headers, payload, query) => {
  if (url.match(/5ch\.net\/test\/bbs\.cgi.*?/)) {
    try {
      let place = headers['x-postplace']
      let resnum = parseInt(headers['x-resnum'])
      if (!place || !resnum) return
      let board = place.replace(/(\w+)\/\d+/, '$1')
      let threadurl = url.replace(/bbs\.cgi.*/, `read.cgi/${place}/`)
      let board2slip = tools.conf.get('bbsslip_verify') || {}
      if (board2slip[board] === undefined) return
      tools.get_res(threadurl).then(async (r) => {
        await new Promise(resolve => setTimeout(resolve, 2000))
        let res = r.data.thread_array[resnum - 1]
        if (res) {
          if (res.id2 && !res.ip) {
            tools.conf.set('bbsslip_verify', { ...board2slip, [board]: res.id2 })
          }
        }
      })
    } catch (e) {
      console.error(e)
    }
  }
}
